/*
 * $Id: challenge.h,v 1.1.1.1 2002/10/14 06:49:25 skyper Exp $
 */

#ifndef __CHALLENGE_H__
#define __CHALLENGE_H__ 1

#include "crypto.h"

struct _THCch1
{
	char A_noince[CHL_SIZE];
	char A_dh_p[DH_P_SIZE];  /* FIXME: What's the need to transfer this */
	char A_dh_pub[DH_PUB_SIZE];
};

struct _THCch2
{
	char B_noince[CHL_SIZE];
	char B_dh_pub[256];
};

struct _THCsignA
{
	char A_noince[CHL_SIZE];
	char B_noince[CHL_SIZE];
	char key[DH_KEY_SIZE];
};

struct _THCsignB
{
	char B_noince[CHL_SIZE];
	char A_noince[CHL_SIZE];
};

#if 0
/*
 * thcch1 is send by the initiator
 */
struct _thcch1
{
	char initiator_chl[CHL_SIZE];
	/* We might want to put garbage here */
	char sig[0];
};

struct _thcch2
{
	char initiator_chl[CHL_SIZE];
	union _thcch2_un
	{
		struct _thcch2_st
		{
			char initiator_iv[IV_SIZE];
			char initiator_key[KEY_SIZE];
			char initiator_hmackey[KEY_SIZE];
			char responder_chl[CHL_SIZE];
		} st;
		char random[sizeof(struct _thcch2_st)];
	} un;
};

struct _thcch3
{
	char responder_chl[CHL_SIZE];
	union _thcch3_un
	{
		struct _thcch3_st
		{
			char responder_iv[IV_SIZE];
			char responder_key[KEY_SIZE];
			char responder_hmackey[KEY_SIZE];
			char initiator_chl[CHL_SIZE];
		} st;
		char random[sizeof(struct _thcch3_st)];
	} un;
};
#endif


int A_send(char *nick); /* send only */
int B_answer(char *nick, char *msg);
int A_sign(char *nick, char *msg);
int B_sign(USER *u, char *g_buf, size_t dlen);
int A_final(USER *u, char *g_buf, size_t dlen); /* recv. only */

#endif /* !__CHALLGENGE_H__ */
