/*
 * $Id: crypto_func.h,v 1.1.1.1 2002/10/14 06:49:25 skyper Exp $
 */

#ifndef __CRYPTO_FUNC_H__
#define __CRYPTO_FUNC_H__ 1
#include <openssl/evp.h>
#include <openssl/dh.h>
#include "crypto.h"
#include "user.h"

char *get_random(char *buf, size_t count);
int gen_keys(char *password);
EVP_PKEY *ReadPublicKey(const char *certfile);
EVP_PKEY *ReadPrivateKey(const char *keyfile, char *password);
char *fingerprint(EVP_PKEY *pkey);
char *fingerprint_rsa(RSA *rsa);
char *fingerprint_raw(unsigned char *data, int len);
unsigned int key_size(EVP_PKEY *pkey);
int message_enc(USER *u, char *src, size_t slen);
int message_dec(CM *dec, char *dst, size_t *dlen, char *src, size_t slen);
DH *DH_param_gen(int bits);
int DH_init_keys(char *kbuf, USER *u, DH *dh, BIGNUM *pub, char who);

#endif /* !__CRYPTO_H__ */

