/*
 * $Id: sanitize.c,v 1.1.1.1 2002/10/14 06:49:25 skyper Exp $
 */

#include "common.h"
#include <stdlib.h>
#include <string.h>

static char isprint_table[] = "???????????????????????????????? !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~?????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????";

/*
 * This should not do any harm to the terminal or to fopen() operations
 */
static char nick_table[]    = "???????????????????????????????????????""'""?????""-""??0123456789???????ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}??????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????????";

unsigned char *
sanitize_nick(unsigned char *dst, unsigned char *nick)
{
	int i = strlen(nick);

	/* Internal error */
	if (sizeof nick_table != 256 + 1)
		exit(-1);

	while (--i > 0)
		dst[i] = nick_table[nick[i]];

	return dst;
}

