/*
 * $Id: user.h,v 1.1.1.1 2002/10/14 06:49:25 skyper Exp $
 */

#ifndef __USER_H__
#define __USER_H__ 1

#include <openssl/evp.h>
#include "irc.h"
#include "crypto.h"

#define STATE_PUBSENT     1
#define STATE_A_WAIT4SIGN 2   /* Alice is waiting for signature */
#define STATE_B_WAIT4SIGN 3   /* Bob is waiting for signature   */
#define STATE_ESTABLISHED 4


/*
 * User Handshake Material.
 * Only required during handshake. Free'd afterwards.
 */
struct user_sm
{
	char A_noince[CHL_SIZE];
	char B_noince[CHL_SIZE];
	char kbuf[DH_KEY_SIZE];
	DH *dh;
};

/*
 * FIXME: also put this struct into a double linked
 * list. Put the last active always on top.
 *
 * Keep two seperate list for pre-auth and
 * auth users. If list is full use longest not used
 * user (e.g. last in list).
 */
typedef struct _user
{
	struct _user *next;
	char nick[MAX_NICK_LEN];
	char anick[MAX_NICK_LEN];
	unsigned char state;
	struct user_sm *usm;
	char flags;
	CM enc;
	CM dec;
} USER;

/*
 * We are Alice
 */
#define USER_FL_ALICE     (0x01)


USER *USER_add(const char *nick);
USER *USER_lookup(const char *nick);
int USER_init(USER *u);
void USER_free_usm(USER *u);
int USER_n(void);
USER *USER_next(USER *u);
char *USER_state(USER *u);
void USER_del(char *nick);

#endif /* !__USER_H__ */
